﻿Type=Class
Version=2.71
@EndOfDesignText@
' Class module ClsDialog version 0.1
' Written by dRachmad
' v 0.1 2013.06.16
'
Sub Class_Globals
	Public DialogType As Int
	Public InputText As Int = 1			
	Public MessageBox As Int = 3	
	
	Private holder, pnlButtons As Panel
	Private pnlMain, pnlMiddle As Panel
	Dim btnOK, btnCancel As Button
	Private lblTitle As Label
	Private strTitle As String
	Private btnHeight, btnWidth, btnSpace, lblHeight As Int
		
	Private intTextSize As Int = 15
	
	Private mTarget As Object
	Private mEventName As String
	Private mEditText As EditText
	Private mWebView As WebView
	
	Dim mSelection As String
	Dim mButton As Int = 2

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Target As Object, EventName As String)
	mTarget = Target
	mEventName = EventName
	
	If SubExists(mTarget, mEventName & "_Closed") = False Then
		ToastMessageShow("There is no " & mEventName & "_Closed", False)
		Return
	End If

End Sub

#Region  Property 

Public Sub setTitle(Title As String)
	strTitle  = Title
End Sub

' For <b>HTML format</b> the size is 1-7
Public Sub setTextSize(Size As Int)
	intTextSize  = Size
End Sub

Public Sub setDefault(DefaultValue As String)
	mSelection = DefaultValue
End Sub

Public Sub setNoButton(NoOfButton As String)
	mButton = NoOfButton
End Sub

Public Sub getSelection As String
	Dim Selection As String
	Select Case DialogType
		Case InputText
			Selection = mEditText.text
	End Select 
	
	Return Selection
End Sub

'Public Sub setObject(ViewObject As Object)
'	mObject  = ViewObject
'End Sub

#End Region

Public Sub AddView(Parent As Activity, Left As Int, Top As Int, Width As Int, Height As Int, cDialogType As Int)
	DialogType = cDialogType
	
	holder.Initialize("holder")
	Hide_holder
'	holder.Color = Colors.ARGB(102, 0, 0, 0)
	Parent.AddView(holder, 0, 0, 100%x, 100%y)
	
	lblHeight = 50dip
	
	Select DialogType
		Case InputText
			InitializeInputText
		Case MessageBox
			InitializeMessageBox
	End Select
	
	btnSpace = 1dip	
	btnHeight = 50dip
	btnWidth = Width/mButton-btnSpace
		
	pnlMain.Initialize("pnlMain")
	pnlMain.Color = Colors.RGB(248, 248, 255)
	
	holder.AddView(pnlMain, Left, Top, Width, Height + btnHeight + lblHeight + 4dip)	
	
	If strTitle <> "" Then
		lblTitle.Initialize("")
		lblTitle.Color = Colors.RGB(51, 181, 229) 
		lblTitle.TextSize = 15
		lblTitle.TextColor = Colors.Black
		lblTitle.Text = strTitle
		lblTitle.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
		pnlMain.AddView(lblTitle, 0, 0, pnlMain.Width, lblHeight)
	Else
		pnlMain.Height = pnlMain.Height - lblHeight
		lblHeight = 0
	End If
			
	pnlMiddle.Initialize("")
	pnlMain.AddView(pnlMiddle, 0, lblHeight + 4dip, pnlMain.Width, Height)
	Select DialogType
		Case InputText
			pnlMiddle.AddView(mEditText, 0, 0, pnlMiddle.Width, pnlMiddle.Height)
		Case MessageBox
			pnlMiddle.AddView(mWebView, 0, 0, pnlMiddle.Width, pnlMiddle.Height)
	End Select
	
	' BUTTON
	
	Dim gd As GradientDrawable
	gd.Initialize("LEFT_RIGHT", Array As Int(Colors.White, Colors.Gray, Colors.White))
	
	pnlButtons.Initialize("")
	pnlButtons.Background = gd
	pnlMain.AddView(pnlButtons, 0, pnlMain.Height - btnHeight, pnlMain.Width, btnHeight)
	
	btnOK.Initialize("btnOK")
	btnOK.Text = "O K"
	btnOK.color = Colors.RGB(248, 248, 255)
	btnOK.TextSize = 15
	btnOK.TextColor = Colors.black
	pnlButtons.AddView(btnOK, pnlButtons.Width - btnWidth, 2dip, btnWidth, btnHeight-2dip)

	If mButton = 2 Then
		btnCancel.Initialize("btnCancel")
		btnCancel.Text = "Cancel"
		btnCancel.color = Colors.RGB(248, 248, 255)
		btnCancel.TextSize = 15
		btnCancel.TextColor = Colors.black
		pnlButtons.AddView(btnCancel, 0, 2dip, btnWidth, btnHeight-2dip)
	End If
	
End Sub

Public Sub Show
	holder.Visible = True
End Sub

Private Sub Hide_holder
	holder.Visible = False
End Sub

Private Sub InitializeInputText
	mEditText.Initialize("")
	mEditText.text = mSelection
	mEditText.TextSize = intTextSize
	mEditText.TextColor = Colors.white
	mEditText.Gravity = Gravity.Top
End Sub

Private Sub InitializeMessageBox
	mWebView.Initialize("")
	mWebView.LoadHtml("<html><body><font size=" & intTextSize & ">" & mSelection  & "</font><body></html>")
	mWebView.ZoomEnabled = True
End Sub

Private Sub btnCancel_Click
	Dim IME As IME
	IME.Initialize("")
	IME.HideKeyboard
	CallSub3(mTarget, mEventName & "_Closed", True, getSelection)
	holder.RemoveView
End Sub

Private Sub btnOK_Click
	Dim IME As IME
	IME.Initialize("")
	IME.HideKeyboard
	CallSub3(mTarget, mEventName & "_Closed", False, getSelection)
	holder.RemoveView
End Sub

Private Sub pnlMain_Click
	' empty to consume the events
End Sub
