﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module ClsWheelCounter 
'
Sub Class_Globals
	Private intWheelType As Int
	Private TimeUp As Int = 1
	Private TimeDown As Int = 2
	Private CounterUp As Int = 3
	Private CounterDown As Int = 4
	Private Clock As Int = 5
	
	Public mWheelTimeId As Int

	Private pnlMain, pnlMiddle As Panel
	Private scvWheel(6) As ScrollView
	Private objWheel(6) As Reflector
	
	Private lblHeight As Int
	Private ColWidths() As Int
	Private TotalColWidths() As Int
	Private WheelNb As Int = 6		
	Private FontSize As Float
	Private IntTextSize As Int = 15
	Private ScrollUp As Boolean
	
	Private pnlButtons As Panel
	Private btnOK, btnCancel, btnMid As Button
	Private lblTitle As Label
	Private strTitle As String
	Private ttlHeight As Int
	Private mButton, btnHeight, btnWidth, btnSpace As Int
	Private mDefault As String
	Private mSelection As String
	
	Public Left As Int
	Public Top As Int
	Public Width As Int
	Public Height As Int
	
	Private WheelContent() As List
	Private ScrollPos() As Int 
	
	Private TimerWheel As Timer	
	Private blnAllowSet As Boolean
	Private y1 As Int 
	Private t1 As Long
	Private speed As Double
	Private CurrentScrollView As ScrollView
	
	Private holder As Panel
	Public TimeActive As Int = 0
		
	Private mTarget As Object
	Private mEventName As String
	Private mParent As Activity
	
	Private lstLap As List
	Private timezone As Long = -DateTime.DateParse("01/01/1970")
	
End Sub

Public Sub Initialize (Target As Object, EventName As String)
	' A Class Module should always have an initialize
	mTarget = Target
	mEventName = EventName
	
	If SubExists(mTarget, mEventName & "_Closed") = False Then
		ToastMessageShow("There is no " & mEventName & "_Closed", False)
		Return
	End If
	
End Sub

Public Sub AddView(Parent As Activity, WheelTimeId As Int)
	mParent = Parent
	mWheelTimeId = WheelTimeId
	
	Dim NoOfView As Int = Parent.NumberOfViews - 1
	
	holder.Initialize("holder")
	Hide_holder
	
	Width = 80%x
	Height = .6 * Width
	Top = 7%Y + NoOfView * (Height + 4dip)
	Left = 50%x - Width / 2
		
	Parent.AddView(holder, 0, 0, 100%x, 100%y)
		
	pnlMain.Initialize("pnlMain")
	pnlMain.Color = Colors.White
	holder.AddView(pnlMain, Left, Top, Width, Height)
	
	ttlHeight = 50dip

	If strTitle <> "" Then
		lblTitle.Initialize("title")
		lblTitle.Color = Colors.RGB(51, 181, 229) 
		lblTitle.TextSize = IntTextSize
		lblTitle.TextColor = Colors.Black
		lblTitle.Text = strTitle
		lblTitle.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
		pnlMain.AddView(lblTitle, 0, 0, pnlMain.Width, ttlHeight)
	Else
		pnlMain.Height = pnlMain.Height - ttlHeight
		ttlHeight = 0
	End If
	
	btnHeight = 50dip
	
	Select Case intWheelType
		Case TimeUp
			mButton = 2
			ScrollUp = True
		Case TimeDown
			mButton = 2
			ScrollUp = False
		Case CounterUp
			mButton = 3
			ScrollUp = True
		Case CounterDown
			mButton = 3
			ScrollUp = False
		Case Clock
			mButton = 0
			ScrollUp = True
			pnlMain.Height = pnlMain.Height - btnHeight
	End Select
		
	If mButton > 0 Then
		Dim gdw As GradientDrawable
		gdw.Initialize("LEFT_RIGHT", Array As Int(Colors.White, Colors.Gray, Colors.White))
	
		btnSpace = 1dip	
		btnWidth = (pnlMain.Width-(mButton-1)*btnSpace)/mButton
	
		pnlButtons.Initialize("")
		pnlButtons.Background = gdw
		pnlMain.AddView(pnlButtons, 0, pnlMain.Height - btnHeight, pnlMain.Width, btnHeight)
	
		btnOK.Initialize("btnOK")
		btnOK.Text = "Start"
		btnOK.color = Colors.RGB(248, 248, 255)
		btnOK.TextSize = IntTextSize
		btnOK.TextColor = Colors.Black
		pnlButtons.AddView(btnOK, pnlButtons.Width - btnWidth, 2dip, btnWidth, btnHeight-2dip)
			
		If mButton > 1 Then
			btnCancel.Initialize("btnCancel")
			btnCancel.Text = "Reset/Del"
			btnCancel.color = Colors.RGB(248, 248, 255)
			btnCancel.TextSize = IntTextSize
			btnCancel.TextColor = Colors.Black
			pnlButtons.AddView(btnCancel, 0, 2dip, btnWidth, btnHeight-2dip)
		End If
		
		If mButton = 3 Then
			btnMid.Initialize("btnMid")
			btnCancel.Text = "Count/Del"
			btnMid.Text = "Count"
			btnOK.Text = "Count"
			btnMid.color = Colors.RGB(248, 248, 255)
			btnMid.TextSize = IntTextSize
			btnMid.TextColor = Colors.Black
			pnlButtons.AddView(btnMid, btnWidth+btnSpace, 2dip, btnWidth, btnHeight-2dip)
		End If
	Else
		btnHeight = 0
	End If
	
	'
	' START OF THE COUNTER ALGORITHM
	'
	TimerWheel.Initialize("TimerWheel", 200)	' need for scrolling manually
	
	WheelNb = 6

	Dim Separation As Int = 5dip
	Dim WheelWidth As Int = (pnlMain.Width-2*Separation)/6 
	Dim ColWidths(WheelNb) As Int
	For i = 0 To WheelNb -1
		ColWidths(i) = WheelWidth
	Next
	Dim TotalColWidths(WheelNb+1) As Int
	TotalColWidths(0) = 0
	For i = 0 To WheelNb - 1
		TotalColWidths(i + 1) = TotalColWidths(i) + ColWidths(i)
		If i = 1 OR i = 3 Then
			TotalColWidths(i + 1) = TotalColWidths(i+1) + Separation
		End If
	Next
	Dim offset As Int = (pnlMain.Width - TotalColWidths(6))/2
	
'	Dim scvWheel(WheelNb) As ScrollView
'	Dim objWheel(WheelNb) As Reflector
	
	pnlMiddle.Initialize("pnlMiddle")
	pnlMain.AddView(pnlMiddle, offset, 4dip + ttlHeight , pnlMain.Width, pnlMain.Height - btnHeight - ttlHeight-8dip)
	pnlMiddle.Color = Colors.gray
	
	lblHeight = 0.8 * pnlMiddle.Height
	FontSize =  0.8 * lblHeight
	
	InitializeWheel
	
	For i = 0 To WheelNb - 1
		scvWheel(i).Initialize2(lblHeight * WheelContent(i).Size, "scv")
		pnlMiddle.AddView(scvWheel(i), TotalColWidths(i), 0, ColWidths(i), pnlMiddle.Height)
	
		scvWheel(i).Tag = i			' use to detect the wheel number
		scvWheel(i).Panel.Color = Colors.black
		
		objWheel(i).Target = scvWheel(i)
		objWheel(i).RunMethod2("setVerticalScrollBarEnabled", False, "java.lang.boolean")
		' should not scroll on touch (prevent scrolling manually)
		objWheel(i).SetOnTouchListener("scv_Touch")
		
		' Fill the content to the Scrollview
		For j = 0 To WheelContent(i).Size - 1
			Dim lbl As Label
			lbl.Initialize("")
			scvWheel(i).Panel.AddView(lbl, 0, j * lblHeight, ColWidths(i), lblHeight)
			lbl.Gravity = Gravity.CENTER_HORIZONTAL + Gravity.CENTER_VERTICAL
			lbl.Color = Colors.Transparent	' don't change, needed when overlay
			lbl.TextColor = Colors.white
			lbl.TextSize = FontSize
			lbl.Text = WheelContent(i).get(j)
		Next
	Next
	
	' Labeling of the columns
	If intWheelType <> CounterUp AND intWheelType <> CounterDown Then 
		Dim pnlText As Panel
		pnlText.Initialize("")
		Dim lblC(3) As Label
		For i = 0 To 2
			lblC(i).Initialize("")
			lblC(i).TextSize = 15
			lblC(i).Textcolor = Colors.White
		Next
		lblC(0).Text = "h"
		lblC(1).Text = "m"
		lblC(2).Text = "s"
		pnlText.AddView(lblC(0),TotalColWidths(2)- 20dip,0, 15dip, 20dip)
		pnlText.AddView(lblC(1),TotalColWidths(4)- 20dip,0, 15dip, 20dip)
		pnlText.AddView(lblC(2),TotalColWidths(6)- 15dip,0, 15dip, 20dip)
		pnlMiddle.AddView(pnlText,0,pnlMiddle.Height - 20dip, pnlMiddle.Width, 20dip)
	End If
		
	lstLap.Initialize
	
End Sub

#Region  Touch Scroll 

Sub scv_Touch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
		
	If blnAllowSet Then
		CurrentScrollView = Sender
		' Hide the pre & post digit
		' Not an elegant solution, any alternative???
		Dim lbl0 As Label
		lbl0.Initialize("")
		lbl0 = scvWheel(CurrentScrollView.tag).Panel.GetView(0)
		lbl0.visible = False
		Dim last As Int
		last = scvWheel(CurrentScrollView.tag).Panel.NumberOfViews - 1
		Dim lbl9 As Label
		lbl9.Initialize("")
		lbl9 = scvWheel(CurrentScrollView.tag).Panel.GetView(last)
		lbl9.visible = False
		
'		Log("Scroll: " & CurrentScrollView.ScrollPosition & " " & lblHeight)
'		Log("Scroll: " & Action & " " & X & " " & Y)
		Dim tt As Int
		Dim dt As Long
		Select Action
		Case 0	' ACTION_DOWN
			t1 = DateTime.Now
			y1 = Y
		Case 1	' ACTION_UP
			tt = Max(10, -Logarithm(1 / speed, cE) * 110)
			CurrentScrollView = Sender
			TimerWheel.Interval = tt * 1.5
			TimerWheel.Enabled = True
		Case 2	' ACTION_MOVE
			dt = (DateTime.Now - t1)
			speed = Abs((Y - y1) / dt * 250)
			y1 = Y
			t1 = DateTime.Now
		End Select
		Return False
	Else
		' prevent from scrolling manually
		Return True
	End If
	
End Sub

Private Sub TimerWheel_Tick
	TimerWheel.Enabled = False
	ScrollFinish(CurrentScrollView, CurrentScrollView.ScrollPosition)
End Sub

Private Sub ScrollFinish(S As ScrollView, Pos As Int)
	Dim i, PosNew As Int

	i = S.Tag	' Wheel No
		
	' Search for the nearest position
	' skip the first and last position (pre & post digit)
	If Pos < lblHeight Then
		ScrollPos(i) = lblHeight
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", ScrollPos(i), "java.lang.int")
	Else If Pos >  (WheelContent(i).Size-2) * lblHeight Then
		ScrollPos(i) = (WheelContent(i).Size-2) * lblHeight 
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", ScrollPos(i), "java.lang.int")
	Else 
		Dim PosNew As Int = Round(Pos/lblHeight)
		ScrollPos(i) = PosNew * lblHeight
'		Log("ScrollFinish: " & Pos & " " & ScrollPos(i))
		objWheel(i).RunMethod3("smoothScrollTo", 0, "java.lang.int", ScrollPos(i), "java.lang.int")
	End If
End Sub

#End Region

#Region  Property 

' Set and get Wheel type
' 1 = Count Up (Stopwatch)
' 2 = Count Down (Timer)
' 3 = Clock
Public Sub setWheelType(WheelType As Int)
	intWheelType  = WheelType
End Sub

Public Sub getWheelType() As Int
	Return intWheelType
End Sub

Public Sub setTitle(Title As String)
	strTitle = Title
End Sub

Public Sub getTitle As String
	Return lblTitle.text
End Sub

Public Sub setTextSize(Size As Int)
	IntTextSize  = Size
End Sub

Public Sub setDefault(DefaultValue As String)
	mDefault = DefaultValue
End Sub

Public Sub setNoButton(NoOfButton As String)
	mButton = NoOfButton
End Sub

Public Sub getSelection() As String
	mSelection = ""
	Dim i, j As Int
	For i = 0 To 5
		j = Floor(ScrollPos(i)/lblHeight)
		mSelection = mSelection & (j-1)
	Next
	Return mSelection
End Sub

#End Region

Private Sub InitializeWheel
	Dim i As Int
		
	Dim WheelContent(WheelNb) As List
		
	' a Space can be use for the pre & post value
	' but the effect is better if using a number
	
	For i = 0 To WheelNb-1
		WheelContent(i).Initialize
		Select i
			Case 2, 4
				If (intWheelType <> CounterUp) AND (intWheelType <> CounterDown)  Then
					WheelContent(i).Add("5")			' pre value
				Else
					WheelContent(i).Add("9")			' pre value
				End If
			Case Else
				WheelContent(i).Add("9")			' pre value
		End Select
		For j = 0 To 9
			WheelContent(i).Add(j)
		Next	
	Next
	
	If (intWheelType <> CounterUp) AND (intWheelType <> CounterDown)  Then
		' for time display
		WheelContent(2).RemoveAt(10)	' remove digit 9
		WheelContent(2).RemoveAt(9)		' remove digit 8
		WheelContent(2).RemoveAt(8)		' remove digit 7
		WheelContent(2).RemoveAt(7)		' remove digit 6
		
		WheelContent(4).RemoveAt(10)	' remove digit 9
		WheelContent(4).RemoveAt(9)		' remove digit 8
		WheelContent(4).RemoveAt(8)		' remove digit 7
		WheelContent(4).RemoveAt(7)		' remove digit 6
	End If
	
	For i = 0 To WheelNb-1
		WheelContent(i).Add("0")					' post value
	Next
	
End Sub

Public Sub Show()
	If intWheelType = TimeUp OR intWheelType = CounterUp Then
		blnAllowSet = False
	Else
		blnAllowSet = True	
	End If
	
	holder.Visible = True	' don't put after the initdefaultvalues!
	InitDefaultValues(mDefault)
	
	button_text
	
End Sub

Private Sub Hide_holder
	holder.Visible = False
End Sub

Public Sub InitDefaultValues(DefaultValue As String)
	Dim i As Int
	
	Dim ScrollPos(6) As Int
	ScrollPos(0) = (DefaultValue.SubString2(0,1)+1) * lblHeight
	ScrollPos(1) = (DefaultValue.SubString2(1,2)+1) * lblHeight
	ScrollPos(2) = (DefaultValue.SubString2(2,3)+1) * lblHeight
	ScrollPos(3) = (DefaultValue.SubString2(3,4)+1) * lblHeight
	ScrollPos(4) = (DefaultValue.SubString2(4,5)+1) * lblHeight
	ScrollPos(5) = (DefaultValue.SubString2(5,6)+1) * lblHeight
	
'	Log(ScrollPos(0) & " " & ScrollPos(1) & " " & ScrollPos(2) & " " & ScrollPos(3) & " " & ScrollPos(4) & " " & ScrollPos(5))
		
	For i = 0 To WheelNb - 1
		Dim intPos As Int = ScrollPos(i)
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", intPos, "java.lang.int")
		DoEvents
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", intPos, "java.lang.int")
		DoEvents
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", intPos, "java.lang.int")
		DoEvents
		objWheel(i).RunMethod3("scrollTo", 0, "java.lang.int", intPos, "java.lang.int")
		DoEvents
		DoEvents
		DoEvents
	Next
	
End Sub

Public Sub SixDigitScroll
'	Log("SixDigitScroll: " & TimeActive & " " & intWheelType)

	If TimeActive = 1 Then
	
		Dim i As Int = 5
		
		If ScrollUp Then
			Do While i >= 0 
				ScrollPos(i) = ScrollPos(i) + lblHeight
				If ScrollPos(i) > (WheelContent(i).Size-2) * lblHeight Then
					ScrollPos(i) = lblHeight
					ResetScroll(i, True)
				Else
					Exit
				End If
				i = i - 1
			Loop
		Else 
			Do While i >= 0 
				ScrollPos(i) = ScrollPos(i) - lblHeight
				If ScrollPos(i) < lblHeight Then
					ScrollPos(i) = (WheelContent(i).Size-2) * lblHeight
					ResetScroll(i, False)
				Else
					Exit
				End If
				i = i - 1
			Loop
		End If
		
		For i = 0 To 5
			objWheel(i).RunMethod3("smoothScrollTo", 0, "java.lang.int", ScrollPos(i) , "java.lang.int")
		Next
		
		Dim intSelection As Int = getSelection
		If ScrollUp Then
			If intSelection = 995959 Then
				TimeActive = 0
				StartServiceAt(AlarmService,DateTime.Now,True)
			End If
		Else
			If intSelection = 0 Then
				TimeActive = 0
				StartServiceAt(AlarmService,DateTime.Now,True)
				btnOK_Click
			End If
		End If
			
	End If
	
End Sub

Private Sub ResetScroll(WheelNo As Int, Up As Boolean)

	If Up Then
		objWheel(WheelNo).RunMethod3("scrollTo", 0, "java.lang.int", 0 , "java.lang.int")
	Else
		objWheel(WheelNo).RunMethod3("scrollTo", 0, "java.lang.int", (WheelContent(WheelNo).Size-1)* lblHeight, "java.lang.int")
	End If 
	
End Sub

Private Sub TwoDigitScroll(Group As Int)
'	Log("TwoDigitScroll:" & TimeActive & " " & intWheelType)

	Dim blnCont As Boolean = True
	Dim IntSelection As Int = getSelection.SubString2(Group*2-2,Group*2)
	
	If ScrollUp Then 
		If IntSelection = 99 Then
			blnCont = False
		End If
	Else 
		If IntSelection = 0 Then
			blnCont = False
		End If
	End If	
	
	If blnCont Then
		Dim intIndex As Int = Group*2-1
		If ScrollUp Then
			ScrollPos(intIndex) = ScrollPos(intIndex) + lblHeight
			If ScrollPos(intIndex) > (WheelContent(intIndex).Size-2) * lblHeight Then
				ScrollPos(intIndex) = lblHeight
				ResetScroll(intIndex, True)
				ScrollPos(intIndex-1) = ScrollPos(intIndex-1) + lblHeight
			End If
			For i = intIndex-1 To intIndex
				objWheel(i).RunMethod3("smoothScrollTo", 0, "java.lang.int", ScrollPos(i) , "java.lang.int")
			Next		
		Else
			Dim intIndex As Int = Group*2-1
			ScrollPos(intIndex) = ScrollPos(intIndex) - lblHeight
			If ScrollPos(intIndex) < lblHeight Then
				ScrollPos(intIndex) = (WheelContent(intIndex).Size-2) * lblHeight
				ResetScroll(intIndex, False)
				ScrollPos(intIndex-1) = ScrollPos(intIndex-1) - lblHeight
			End If
			For i = intIndex-1 To intIndex
				objWheel(i).RunMethod3("smoothScrollTo", 0, "java.lang.int", ScrollPos(i) , "java.lang.int")
			Next	
		End If
		
		IntSelection = getSelection.SubString2(Group*2-2,Group*2)
				
		If ScrollUp Then 
			If IntSelection = 99 Then
				StartServiceAt(AlarmService,DateTime.Now,True)
			End If
		Else 
			If IntSelection = 0 Then
				StartServiceAt(AlarmService,DateTime.Now,True)
			End If
		End If	
		
	End If
	
	Try
'		TimeManager.LastValue = getSelection
	Catch
		Log("empty getSelection")
	End Try
	
End Sub

Public Sub MoveUp
	pnlMain.Top = pnlMain.Top - (Height + 4dip)
End Sub

Private Sub pnlMain_Click
	' empty to consume the events
End Sub

Private Sub btnCancel_Click

	If intWheelType = CounterUp OR intWheelType = CounterDown Then
		TwoDigitScroll(1)
		blnAllowSet = False
	Else
		If btnCancel.Text = "Reset/Del" Then
			InitDefaultValues(mDefault)
			blnAllowSet = True
			lstLap.Clear
		Else If btnCancel.Text = "Lap" Then
			Dim x As String = getSelection
			Dim Formatted As String = x.SubString2(0,2) & ":" & x.SubString2(2,4) & ":" & x.SubString2(4,6)
			lstLap.Add(Formatted)
			lap_display 
			'ToastMessageShow("Lap: " & getSelection,False)
		End If
	End If
	
End Sub

Private Sub btnMid_Click
	TwoDigitScroll(2)
	blnAllowSet = False
End Sub

Private Sub btnOK_Click
'	Log("btnOK_Click")
	If intWheelType = CounterUp OR intWheelType = CounterDown Then
		setDefault(getSelection)
		InitDefaultValues(mDefault)
		TwoDigitScroll(3)
		blnAllowSet = False
	Else
		If btnOK.Text = "Start" Then
			If Not((intWheelType = TimeDown) AND (getSelection = "000000")) Then
				setDefault(getSelection)
				InitDefaultValues(mDefault)
				TimeActive = 1
				blnAllowSet = False
			Else
				Dim Dialog As ClsDialog
				Dialog.Initialize(Me, "Msgbox")
				Dialog.TextSize = 6
				Dialog.mButton = 1
				Dialog.Default = "<center>" & "<b>Timer Down</b><BR><BR>Start should > 0" & "</center>"
				Dialog.AddView(mParent, 20%x, 30%y, 60%x, 20%y, 3) 
				Dialog.Show
			End If
		Else
			TimeActive = 0
		End If
	End If
	
	button_text
	
End Sub

Private Sub Msgbox_Closed (Cancelled As Boolean, Selection As String)
	' not used
End Sub


Sub button_text

	If intWheelType = TimeUp OR intWheelType = TimeDown Then
		If TimeActive = 1 Then
			btnOK.Text = "Stop"
			If intWheelType = TimeUp Then
				btnCancel.Text = "Lap"
			Else
				btnCancel.Text = ""
			End If
		Else
			btnOK.Text = "Start"
			btnCancel.Text = "Reset/Del"
		End If
	End If

End Sub

Private Sub btnCancel_LongClick

	If (btnCancel.Text = "Reset/Del") OR (btnCancel.Text = "Count/Del") Then
		CallSub3(mTarget, mEventName & "_Closed", True, mWheelTimeId)
		holder.RemoveView
	End If
		
End Sub

Private Sub title_click
	Dim Dialog As ClsDialog
	Dialog.Initialize(Me, "TitleDialog")
	Dialog.Default = lblTitle.text
	Dialog.TextSize = 20
	Dim TopDialog As Int = pnlMain.Top+lblTitle.Top + 2* ttlHeight
	If TopDialog > 50%y Then
		TopDialog = 50%y	' prevent hiding by the keyboard
	End If
	Dialog.AddView(mParent, 30%x, TopDialog, 40%x, 50dip, 1) 
	Dialog.Show	
End Sub

Private Sub TitleDialog_Closed (Cancelled As Boolean, Selection As String)

	If Not(Cancelled) Then
		lblTitle.Text = Selection
	End If

End Sub

Private Sub Lap_Closed (Cancelled As Boolean, Selection As String)
	' not used
End Sub

Private Sub lap_display 

	Dim Dialog As ClsDialog
	Dialog.Initialize(Me, "Lap")
	Dim TopDialog As Int = pnlMain.Top+lblTitle.Top + ttlHeight
	Dialog.TextSize = 4
	Dialog.mButton = 1
	Dialog.Default = "<center>" & lap_rpt & "</center>"
	Dialog.AddView(mParent, 30%x, TopDialog, 40%x, 20%y, 3) 
	Dialog.Show
	
End Sub

Private Sub lap_rpt As String
	Dim str As String
	Dim strCounter As String
	Dim duration As String
	Dim lstLapSort As List
	lstLapSort.Initialize
	Dim Previous As String = "00:00:00"
	For i = 0 To lstLap.Size - 1
		str = lstLap.Get(i)
		duration = DateTime.Time(DateTime.TimeParse(str) -  DateTime.TimeParse(Previous) - timezone)
		strCounter = 101 + i
		lstLapSort.Add(strCounter.SubString2(1,3) & ": " & duration & " " & str)
		Previous = str
	Next
	lstLapSort.Sort(False)
	Dim mText As StringBuilder
	mText.Initialize
	For i = 0 To lstLapSort.Size - 1
	 	mText.Append("Lap " & lstLapSort.Get(i) & "<BR>")
	Next
	
	Return mText
	
End Sub
